org.springframework.expression.spel

## Enum SpelMessage

- java.lang.Object
- - java.lang.Enum<SpelMessage>
  - - org.springframework.expression.spel.SpelMessage

- All Implemented Interfaces:
    Serializable, Comparable<SpelMessage>

      public enum SpelMessage
      extends Enum<SpelMessage>

  Contains all the messages that can be produced by the Spring Expression Language. Each message has a kind (info, warn, error) and a code number. Tests can be written to expect particular code numbers rather than particular text, enabling the message text to more easily be modified and the tests to run successfully in different locales.

  When a message is formatted, it will have this kind of form

       EL1004E: (pos 34): Type cannot be found 'String'

  The prefix captures the code and the error kind, whilst the position is included if it is known.
  Since:
    3.0
  Author:
    Andy Clement

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SpelMessage.Kind`

  - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `ARGLIST_SHOULD_NOT_BE_EVALUATED`
    `ARRAY_INDEX_OUT_OF_BOUNDS`
    `BETWEEN_RIGHT_OPERAND_MUST_BE_TWO_ELEMENT_LIST`
    `CANNOT_INDEX_INTO_NULL_VALUE`
    `COLLECTION_INDEX_OUT_OF_BOUNDS`
    `CONSTRUCTOR_INVOCATION_PROBLEM`
    `CONSTRUCTOR_NOT_FOUND`
    `EXCEPTION_DURING_BEAN_RESOLUTION`
    `EXCEPTION_DURING_FUNCTION_CALL`
    `EXCEPTION_DURING_METHOD_INVOCATION`
    `EXCEPTION_DURING_PROPERTY_READ`
    `EXCEPTION_DURING_PROPERTY_WRITE`
    `FUNCTION_MUST_BE_STATIC`
    `FUNCTION_NOT_DEFINED`
    `FUNCTION_REFERENCE_CANNOT_BE_INVOKED`
    `INCORRECT_ELEMENT_TYPE_FOR_ARRAY`
    `INCORRECT_NUMBER_OF_ARGUMENTS_TO_FUNCTION`
    `INDEXING_NOT_SUPPORTED_FOR_TYPE`
    `INITIALIZER_LENGTH_INCORRECT`
    `INSTANCEOF_OPERATOR_NEEDS_CLASS_OPERAND`
    `INVALID_BEAN_REFERENCE`
    `INVALID_FIRST_OPERAND_FOR_MATCHES_OPERATOR`
    `INVALID_PATTERN`
    `INVALID_SECOND_OPERAND_FOR_MATCHES_OPERATOR`
    `INVALID_TYPE_FOR_SELECTION`
    `LEFT_OPERAND_PROBLEM`
    `METHOD_CALL_ON_NULL_OBJECT_NOT_ALLOWED`
    `METHOD_NOT_FOUND`
    `MISSING_ARRAY_DIMENSION`
    `MISSING_CHARACTER`
    `MISSING_CONSTRUCTOR_ARGS`
    `MISSING_LEADING_ZERO_FOR_NUMBER`
    `MISSING_SELECTION_EXPRESSION`
    `MORE_INPUT`
    `MULTIDIM_ARRAY_INITIALIZER_NOT_SUPPORTED`
    `MULTIPLE_POSSIBLE_METHODS`
    `NO_BEAN_RESOLVER_REGISTERED`
    `NON_TERMINATING_DOUBLE_QUOTED_STRING`
    `NON_TERMINATING_QUOTED_STRING`
    `NOT_A_LONG`
    `NOT_A_REAL`
    `NOT_AN_INTEGER`
    `NOT_ASSIGNABLE`
    `NOT_COMPARABLE`
    `NOT_EXPECTED_TOKEN`
    `OOD`
    `OPERAND_NOT_DECREMENTABLE`
    `OPERAND_NOT_INCREMENTABLE`
    `OPERATOR_NOT_SUPPORTED_BETWEEN_TYPES`
    `PROBLEM_LOCATING_METHOD`
    `PROJECTION_NOT_SUPPORTED_ON_TYPE`
    `PROPERTY_OR_FIELD_NOT_READABLE`
    `PROPERTY_OR_FIELD_NOT_READABLE_ON_NULL`
    `PROPERTY_OR_FIELD_NOT_WRITABLE`
    `PROPERTY_OR_FIELD_NOT_WRITABLE_ON_NULL`
    `REAL_CANNOT_BE_LONG`
    `RESULT_OF_SELECTION_CRITERIA_IS_NOT_BOOLEAN`
    `RIGHT_OPERAND_PROBLEM`
    `RUN_OUT_OF_ARGUMENTS`
    `SETVALUE_NOT_SUPPORTED`
    `STRING_INDEX_OUT_OF_BOUNDS`
    `TYPE_CONVERSION_ERROR`
    `TYPE_NAME_EXPECTED_FOR_ARRAY_CONSTRUCTION`
    `TYPE_NOT_FOUND`
    `UNABLE_TO_CREATE_LIST_FOR_INDEXING`
    `UNABLE_TO_CREATE_MAP_FOR_INDEXING`
    `UNABLE_TO_DYNAMICALLY_CREATE_OBJECT`
    `UNABLE_TO_GROW_COLLECTION`
    `UNABLE_TO_GROW_COLLECTION_UNKNOWN_ELEMENT_TYPE`
    `UNEXPECTED_DATA_AFTER_DOT`
    `UNEXPECTED_ESCAPE_CHAR`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String` | `formatMessage(int pos, Object... inserts)` Produce a complete message including the prefix, the position (if known) and with the inserts applied to the message.
    `static SpelMessage` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
    `static SpelMessage[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### TYPE_CONVERSION_ERROR

          public static final SpelMessage TYPE_CONVERSION_ERROR

    - #### CONSTRUCTOR_NOT_FOUND

          public static final SpelMessage CONSTRUCTOR_NOT_FOUND

    - #### CONSTRUCTOR_INVOCATION_PROBLEM

          public static final SpelMessage CONSTRUCTOR_INVOCATION_PROBLEM

    - #### METHOD_NOT_FOUND

          public static final SpelMessage METHOD_NOT_FOUND

    - #### TYPE_NOT_FOUND

          public static final SpelMessage TYPE_NOT_FOUND

    - #### FUNCTION_NOT_DEFINED

          public static final SpelMessage FUNCTION_NOT_DEFINED

    - #### PROPERTY_OR_FIELD_NOT_READABLE_ON_NULL

          public static final SpelMessage PROPERTY_OR_FIELD_NOT_READABLE_ON_NULL

    - #### PROPERTY_OR_FIELD_NOT_READABLE

          public static final SpelMessage PROPERTY_OR_FIELD_NOT_READABLE

    - #### PROPERTY_OR_FIELD_NOT_WRITABLE_ON_NULL

          public static final SpelMessage PROPERTY_OR_FIELD_NOT_WRITABLE_ON_NULL

    - #### PROPERTY_OR_FIELD_NOT_WRITABLE

          public static final SpelMessage PROPERTY_OR_FIELD_NOT_WRITABLE

    - #### METHOD_CALL_ON_NULL_OBJECT_NOT_ALLOWED

          public static final SpelMessage METHOD_CALL_ON_NULL_OBJECT_NOT_ALLOWED

    - #### CANNOT_INDEX_INTO_NULL_VALUE

          public static final SpelMessage CANNOT_INDEX_INTO_NULL_VALUE

    - #### NOT_COMPARABLE

          public static final SpelMessage NOT_COMPARABLE

    - #### INCORRECT_NUMBER_OF_ARGUMENTS_TO_FUNCTION

          public static final SpelMessage INCORRECT_NUMBER_OF_ARGUMENTS_TO_FUNCTION

    - #### INVALID_TYPE_FOR_SELECTION

          public static final SpelMessage INVALID_TYPE_FOR_SELECTION

    - #### RESULT_OF_SELECTION_CRITERIA_IS_NOT_BOOLEAN

          public static final SpelMessage RESULT_OF_SELECTION_CRITERIA_IS_NOT_BOOLEAN

    - #### BETWEEN_RIGHT_OPERAND_MUST_BE_TWO_ELEMENT_LIST

          public static final SpelMessage BETWEEN_RIGHT_OPERAND_MUST_BE_TWO_ELEMENT_LIST

    - #### INVALID_PATTERN

          public static final SpelMessage INVALID_PATTERN

    - #### PROJECTION_NOT_SUPPORTED_ON_TYPE

          public static final SpelMessage PROJECTION_NOT_SUPPORTED_ON_TYPE

    - #### ARGLIST_SHOULD_NOT_BE_EVALUATED

          public static final SpelMessage ARGLIST_SHOULD_NOT_BE_EVALUATED

    - #### EXCEPTION_DURING_PROPERTY_READ

          public static final SpelMessage EXCEPTION_DURING_PROPERTY_READ

    - #### FUNCTION_REFERENCE_CANNOT_BE_INVOKED

          public static final SpelMessage FUNCTION_REFERENCE_CANNOT_BE_INVOKED

    - #### EXCEPTION_DURING_FUNCTION_CALL

          public static final SpelMessage EXCEPTION_DURING_FUNCTION_CALL

    - #### ARRAY_INDEX_OUT_OF_BOUNDS

          public static final SpelMessage ARRAY_INDEX_OUT_OF_BOUNDS

    - #### COLLECTION_INDEX_OUT_OF_BOUNDS

          public static final SpelMessage COLLECTION_INDEX_OUT_OF_BOUNDS

    - #### STRING_INDEX_OUT_OF_BOUNDS

          public static final SpelMessage STRING_INDEX_OUT_OF_BOUNDS

    - #### INDEXING_NOT_SUPPORTED_FOR_TYPE

          public static final SpelMessage INDEXING_NOT_SUPPORTED_FOR_TYPE

    - #### INSTANCEOF_OPERATOR_NEEDS_CLASS_OPERAND

          public static final SpelMessage INSTANCEOF_OPERATOR_NEEDS_CLASS_OPERAND

    - #### EXCEPTION_DURING_METHOD_INVOCATION

          public static final SpelMessage EXCEPTION_DURING_METHOD_INVOCATION

    - #### OPERATOR_NOT_SUPPORTED_BETWEEN_TYPES

          public static final SpelMessage OPERATOR_NOT_SUPPORTED_BETWEEN_TYPES

    - #### PROBLEM_LOCATING_METHOD

          public static final SpelMessage PROBLEM_LOCATING_METHOD

    - #### SETVALUE_NOT_SUPPORTED

          public static final SpelMessage SETVALUE_NOT_SUPPORTED

    - #### MULTIPLE_POSSIBLE_METHODS

          public static final SpelMessage MULTIPLE_POSSIBLE_METHODS

    - #### EXCEPTION_DURING_PROPERTY_WRITE

          public static final SpelMessage EXCEPTION_DURING_PROPERTY_WRITE

    - #### NOT_AN_INTEGER

          public static final SpelMessage NOT_AN_INTEGER

    - #### NOT_A_LONG

          public static final SpelMessage NOT_A_LONG

    - #### INVALID_FIRST_OPERAND_FOR_MATCHES_OPERATOR

          public static final SpelMessage INVALID_FIRST_OPERAND_FOR_MATCHES_OPERATOR

    - #### INVALID_SECOND_OPERAND_FOR_MATCHES_OPERATOR

          public static final SpelMessage INVALID_SECOND_OPERAND_FOR_MATCHES_OPERATOR

    - #### FUNCTION_MUST_BE_STATIC

          public static final SpelMessage FUNCTION_MUST_BE_STATIC

    - #### NOT_A_REAL

          public static final SpelMessage NOT_A_REAL

    - #### MORE_INPUT

          public static final SpelMessage MORE_INPUT

    - #### RIGHT_OPERAND_PROBLEM

          public static final SpelMessage RIGHT_OPERAND_PROBLEM

    - #### NOT_EXPECTED_TOKEN

          public static final SpelMessage NOT_EXPECTED_TOKEN

    - #### OOD

          public static final SpelMessage OOD

    - #### NON_TERMINATING_DOUBLE_QUOTED_STRING

          public static final SpelMessage NON_TERMINATING_DOUBLE_QUOTED_STRING

    - #### NON_TERMINATING_QUOTED_STRING

          public static final SpelMessage NON_TERMINATING_QUOTED_STRING

    - #### MISSING_LEADING_ZERO_FOR_NUMBER

          public static final SpelMessage MISSING_LEADING_ZERO_FOR_NUMBER

    - #### REAL_CANNOT_BE_LONG

          public static final SpelMessage REAL_CANNOT_BE_LONG

    - #### UNEXPECTED_DATA_AFTER_DOT

          public static final SpelMessage UNEXPECTED_DATA_AFTER_DOT

    - #### MISSING_CONSTRUCTOR_ARGS

          public static final SpelMessage MISSING_CONSTRUCTOR_ARGS

    - #### RUN_OUT_OF_ARGUMENTS

          public static final SpelMessage RUN_OUT_OF_ARGUMENTS

    - #### UNABLE_TO_GROW_COLLECTION

          public static final SpelMessage UNABLE_TO_GROW_COLLECTION

    - #### UNABLE_TO_GROW_COLLECTION_UNKNOWN_ELEMENT_TYPE

          public static final SpelMessage UNABLE_TO_GROW_COLLECTION_UNKNOWN_ELEMENT_TYPE

    - #### UNABLE_TO_CREATE_LIST_FOR_INDEXING

          public static final SpelMessage UNABLE_TO_CREATE_LIST_FOR_INDEXING

    - #### UNABLE_TO_CREATE_MAP_FOR_INDEXING

          public static final SpelMessage UNABLE_TO_CREATE_MAP_FOR_INDEXING

    - #### UNABLE_TO_DYNAMICALLY_CREATE_OBJECT

          public static final SpelMessage UNABLE_TO_DYNAMICALLY_CREATE_OBJECT

    - #### NO_BEAN_RESOLVER_REGISTERED

          public static final SpelMessage NO_BEAN_RESOLVER_REGISTERED

    - #### EXCEPTION_DURING_BEAN_RESOLUTION

          public static final SpelMessage EXCEPTION_DURING_BEAN_RESOLUTION

    - #### INVALID_BEAN_REFERENCE

          public static final SpelMessage INVALID_BEAN_REFERENCE

    - #### TYPE_NAME_EXPECTED_FOR_ARRAY_CONSTRUCTION

          public static final SpelMessage TYPE_NAME_EXPECTED_FOR_ARRAY_CONSTRUCTION

    - #### INCORRECT_ELEMENT_TYPE_FOR_ARRAY

          public static final SpelMessage INCORRECT_ELEMENT_TYPE_FOR_ARRAY

    - #### MULTIDIM_ARRAY_INITIALIZER_NOT_SUPPORTED

          public static final SpelMessage MULTIDIM_ARRAY_INITIALIZER_NOT_SUPPORTED

    - #### MISSING_ARRAY_DIMENSION

          public static final SpelMessage MISSING_ARRAY_DIMENSION

    - #### INITIALIZER_LENGTH_INCORRECT

          public static final SpelMessage INITIALIZER_LENGTH_INCORRECT

    - #### UNEXPECTED_ESCAPE_CHAR

          public static final SpelMessage UNEXPECTED_ESCAPE_CHAR

    - #### OPERAND_NOT_INCREMENTABLE

          public static final SpelMessage OPERAND_NOT_INCREMENTABLE

    - #### OPERAND_NOT_DECREMENTABLE

          public static final SpelMessage OPERAND_NOT_DECREMENTABLE

    - #### NOT_ASSIGNABLE

          public static final SpelMessage NOT_ASSIGNABLE

    - #### MISSING_CHARACTER

          public static final SpelMessage MISSING_CHARACTER

    - #### LEFT_OPERAND_PROBLEM

          public static final SpelMessage LEFT_OPERAND_PROBLEM

    - #### MISSING_SELECTION_EXPRESSION

          public static final SpelMessage MISSING_SELECTION_EXPRESSION

  - ### Method Detail

    - #### values

          public static SpelMessage[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (SpelMessage c : SpelMessage.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static SpelMessage valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

    - #### formatMessage

          public String formatMessage(int pos,
                             Object... inserts)

      Produce a complete message including the prefix, the position (if known) and with the inserts applied to the message.
      Parameters:
        `pos` - the position, if less than zero it is ignored and not included in the message
        `inserts` - the inserts to put into the formatted message
      Returns:
        a formatted message